export function useService(machine, options) {
    const { actions, context, state: hydratedState } = options ?? {};
    const service = typeof machine === "function" ? machine() : machine;
    service.setContext($state.snapshot(context));
    service._created();
    $effect(() => {
        service.setOptions({ actions: $state.snapshot(actions) });
    });
    $effect(() => {
        service.setContext($state.snapshot(context));
    });
    $effect(() => {
        service.start(hydratedState);
        return service.stop;
    });
    return service;
}
